%define daemon_user monitor
%if 0%{?suse_version}
%define htmlroot /srv/www/htdocs
%define httpconfdir apache2/conf.d
%define daemon_group www
%else
%define htmlroot /var/www/html
%define httpconfdir httpd/conf.d
%define daemon_group apache
%endif
Name: monitor-nagvis
Version: 1.7.8.1
Release: op5.1
License: GPLv2
Packager: build@op5
Vendor: op5 AB
BuildRoot: /tmp/%name-%version
Summary: op5 monitor nagvis
Group: op5/Monitor
Prefix: /opt/monitor/op5/nagvis_ls
Source: %name-%version.tar.gz
BuildArch: noarch
Requires: graphviz >= 2.14, monitor-ninja >= 3.0, monitor-livestatus
BuildRequires: rsync
%if 0%{?suse_version}
Requires: php53-mbstring
BuildRequires: apache2
BuildRequires: util-linux
%else
Requires: php-mbstring
BuildRequires: httpd
%endif

%description
Data Visualization plugin for Nagios.

%prep
%setup -q
# change default location of html files for SUSE in all files
%if 0%{?suse_version}
find -type f -exec %{__sed} '{}' -i -e 's#var/www/html#srv/www/htdocs#g'  \;
find -type f -exec %{__sed} '{}' -i -e 's#var/www#srv/www#g'  \;
%endif

%install
#use our own ini file, with our paths - nagvis tries to use %buildroot otherwise:
cp op5build/nagvis.ini.php etc
rm etc/nagvis.ini.php-sample

mkdir -p -m 755 %buildroot/etc/%httpconfdir
sed -e 's|@NAGVIS_WEB@|/nagvis|' -e 's|@NAGVIS_PATH@|%prefix/share|' etc/apache2-nagvis.conf-sample >  %buildroot/etc/%httpconfdir/nagvis.conf

mkdir -p %buildroot/opt/monitor
./install.sh -s monitor -n %buildroot/opt/monitor -b /usr/bin -p %buildroot%prefix \
	-W /nagvis -u %daemon_user -g %daemon_group -a n \
	-i mklivestatus -l unix:/opt/monitor/var/rw/live -r -c n -q -F -w /etc/%{httpconfdir}

rm %buildroot/%prefix/etc/maps/demo*cfg
# install default maps into the /default dir
mkdir -p %buildroot/%prefix/etc/maps/default
cp op5build/demomaps/*.cfg %buildroot%prefix/etc/maps/default

# treat this as a special map, since we expect it to be there so "locate on map" works
cp op5build/demomaps/automap.cfg %buildroot%prefix/etc/maps
rm -f %buildroot%prefix/etc/apache2-nagvis.conf-sample

%pre

%post
# From install.sh:
sed -i '/^allowedforconfig=/d' %prefix/etc/nagvis.ini.php
sed -i '/^autoupdatefreq=/d' %prefix/etc/nagvis.ini.php
sed -i '/^htmlwuijs=/d' %prefix/etc/nagvis.ini.php
sed -i '/^wuijs=/d' %prefix/etc/nagvis.ini.php
sed -i '/^showautomaps=/d' %prefix/etc/nagvis.ini.php
sed -i '/^usegdlibs=/d' %prefix/etc/nagvis.ini.php
sed -i '/^displayheader=/d' %prefix/etc/nagvis.ini.php
sed -i '/^hovertimeout=/d' %prefix/etc/nagvis.ini.php
sed -i 's/^headermenu="0"/headermenu="1"/g' %prefix/etc/nagvis.ini.php
sed -i '/^allowed_for_config=/d' %prefix/etc/maps/*.cfg
sed -i '/^allowed_user=/d' %prefix/etc/maps/*.cfg
sed -i '/^hover_timeout=/d' %prefix/etc/maps/*.cfg
sed -i '/^usegdlibs=/d' %prefix/etc/maps/*.cfg
# remove cache
find %prefix/var/ -type f -maxdepth 1 -exec rm -f {} \;
rm -rf %prefix/var/tmpl/compile/* || :

# Remove old ninja-specific hacks:
sed -i '/^\[ninja\]$/d' %prefix/etc/nagvis.ini.php
sed -i '/^acl_config=/d' %prefix/etc/nagvis.ini.php

# Unholy evilness just shoot me please
sed -i '/header menu in the WUI/{N;/headermenu/d;}' %prefix/etc/nagvis.ini.php
grep -q LogonNinja %prefix/etc/nagvis.ini.php || sed -i 's/^;logonmodule=.*/logonmodule="LogonNinja"/' %prefix/etc/nagvis.ini.php

# install demo maps
if [ "$1" -le 1 ]; then
	for map in %prefix/etc/maps/default/*; do
		cp $map %prefix/etc/maps/$(basename $map)
		chmod 0664 %prefix/etc/maps/$(basename $map)
		chown %daemon_user:%daemon_group %prefix/etc/maps/$(basename $map)
	done
else
	chmod 0664 %prefix/etc/maps/demo*.cfg
	chown %daemon_user:%daemon_group %prefix/etc/maps/demo*.cfg
fi

# Restart apache so we don't get any error in nagivs widget.
%if 0%{?suse_version}
service apache2 restart || :
%else
service httpd restart || :
%endif

%clean
rm -rf %buildroot

%files
%defattr(0644,%daemon_user,%daemon_group,0755)
%prefix/share/config.php
%doc %prefix/share/docs
%prefix/share/frontend
%prefix/share/index.php
%prefix/share/netmap
%prefix/share/server
%doc %prefix/LICENCE
%doc %prefix/README
%config /etc/%httpconfdir/nagvis.conf

%defattr(0664,%daemon_user,%daemon_group,0775)
%dir %prefix/var/tmpl/cache
%dir %prefix/var/tmpl/compile
%prefix/share/userfiles
%prefix/share/var
%prefix/var
%prefix/etc/conf.d
%prefix/etc/geomap
%dir %prefix/etc/maps
%prefix/etc/maps/default
%prefix/etc/profiles
%prefix/etc/.htaccess
%config(noreplace) %prefix/etc/maps/automap.cfg
%config(noreplace) %prefix/etc/nagvis.ini.php
